'use strict';

var React = require('react');
var classnames = require('classnames');
var utilsCommons = require('@highlight-ui/utils-commons');
var Icon = require('@highlight-ui/icon');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classnames__default = /*#__PURE__*/_interopDefaultLegacy(classnames);
var Icon__default = /*#__PURE__*/_interopDefaultLegacy(Icon);

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = "@import url(\"https://fonts.googleapis.com/css2?family=IBM+Plex+Mono:wght@400;700&display=swap\");\n@import url(\"https://fonts.googleapis.com/css2?family=Open+Sans:ital,wght@0,300;0,400;0,600;0,700;1,300;1,400;1,600;1,700&display=swap\");\n@import url(\"https://fonts.googleapis.com/css2?family=IBM+Plex+Mono:wght@400;700&display=swap\");\n@import url(\"https://fonts.googleapis.com/css2?family=Open+Sans:ital,wght@0,300;0,400;0,600;0,700;1,300;1,400;1,600;1,700&display=swap\");\n.Button-module__3Rp1BYXs__v1-1-3 {\n  border: 1px solid transparent;\n  border-radius: 4px;\n  cursor: pointer;\n  display: inline-block;\n  font-family: \"Open Sans\", \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n  font-size: 14px;\n  font-weight: 600;\n  line-height: 18px;\n  margin: 0 0;\n  outline: none;\n  padding: 8px 24px;\n  position: relative;\n  text-decoration: none;\n  transition: all 0.3s ease;\n}\n\n.Button-module__1JxCag8q__v1-1-3 {\n  transform: translateX(-12px);\n}\n\n.Button-module__PkJtfsRC__v1-1-3 {\n  position: absolute;\n  right: 16px;\n  top: 10.5px;\n}\n\n.Button-module__3ZNLhdsJ__v1-1-3 {\n  display: flex;\n  flex: 1;\n  justify-content: center;\n}\n.Button-module__3ZNLhdsJ__v1-1-3 i + div {\n  margin: 0 0 0 4px;\n}\n\n.Button-module__3-vgpZJs__v1-1-3 i {\n  margin: 0;\n}\n\n.Button-module__1xc1DTHJ__v1-1-3 {\n  display: block;\n  width: 100%;\n}\n\n.Button-module__2Kmo3l-q__v1-1-3 {\n  background: #f4f7f9;\n  border-color: transparent;\n  color: #555;\n}\n.Button-module__2Kmo3l-q__v1-1-3:hover {\n  background: #dbe5ec;\n  color: #555;\n  text-decoration: none;\n}\n.Button-module__2Kmo3l-q__v1-1-3:focus, .Button-module__2Kmo3l-q__v1-1-3.Button-module__39s3axLP__v1-1-3 {\n  box-shadow: 0 0 0 0.1rem rgba(244, 247, 249, 0.75);\n  outline: none;\n  background: #d3dfe7;\n  color: #555;\n}\n.Button-module__2Kmo3l-q__v1-1-3:active, .Button-module__2Kmo3l-q__v1-1-3.Button-module__3WXlxxv-__v1-1-3 {\n  background: #cbd9e3;\n}\n.Button-module__2Kmo3l-q__v1-1-3:disabled, .Button-module__2Kmo3l-q__v1-1-3.Button-module__yB64MUUF__v1-1-3 {\n  cursor: initial;\n  opacity: 0.3;\n}\n\n.Button-module__2nxVbZSO__v1-1-3 {\n  background: #0db5df;\n  border-color: transparent;\n  color: #fff;\n}\n.Button-module__2nxVbZSO__v1-1-3:hover {\n  background: #0b98bb;\n  color: #fff;\n  text-decoration: none;\n}\n.Button-module__2nxVbZSO__v1-1-3:focus, .Button-module__2nxVbZSO__v1-1-3.Button-module__39s3axLP__v1-1-3 {\n  box-shadow: 0 0 0 0.1rem rgba(13, 181, 223, 0.75);\n  outline: none;\n  background: #0a8eaf;\n  color: #fff;\n}\n.Button-module__2nxVbZSO__v1-1-3:active, .Button-module__2nxVbZSO__v1-1-3.Button-module__3WXlxxv-__v1-1-3 {\n  background: #0984a3;\n}\n.Button-module__2nxVbZSO__v1-1-3:disabled, .Button-module__2nxVbZSO__v1-1-3.Button-module__yB64MUUF__v1-1-3 {\n  cursor: initial;\n  opacity: 0.3;\n}\n\n.Button-module__2WMN2Up2__v1-1-3 {\n  background: #74c970;\n  border-color: transparent;\n  color: #fff;\n}\n.Button-module__2WMN2Up2__v1-1-3:hover {\n  background: #59bf54;\n  color: #fff;\n  text-decoration: none;\n}\n.Button-module__2WMN2Up2__v1-1-3:focus, .Button-module__2WMN2Up2__v1-1-3.Button-module__39s3axLP__v1-1-3 {\n  box-shadow: 0 0 0 0.1rem rgba(116, 201, 112, 0.75);\n  outline: none;\n  background: #50bb4b;\n  color: #fff;\n}\n.Button-module__2WMN2Up2__v1-1-3:active, .Button-module__2WMN2Up2__v1-1-3.Button-module__3WXlxxv-__v1-1-3 {\n  background: #49b544;\n}\n.Button-module__2WMN2Up2__v1-1-3:disabled, .Button-module__2WMN2Up2__v1-1-3.Button-module__yB64MUUF__v1-1-3 {\n  cursor: initial;\n  opacity: 0.3;\n}\n\n.Button-module__3Ll-h-cW__v1-1-3 {\n  background: #0b98bb;\n  border-color: transparent;\n  color: #fff;\n}\n.Button-module__3Ll-h-cW__v1-1-3:hover {\n  background: #097b97;\n  color: #fff;\n  text-decoration: none;\n}\n.Button-module__3Ll-h-cW__v1-1-3:focus, .Button-module__3Ll-h-cW__v1-1-3.Button-module__39s3axLP__v1-1-3 {\n  box-shadow: 0 0 0 0.1rem rgba(11, 152, 187, 0.75);\n  outline: none;\n  background: #08718b;\n  color: #fff;\n}\n.Button-module__3Ll-h-cW__v1-1-3:active, .Button-module__3Ll-h-cW__v1-1-3.Button-module__3WXlxxv-__v1-1-3 {\n  background: #07677f;\n}\n.Button-module__3Ll-h-cW__v1-1-3:disabled, .Button-module__3Ll-h-cW__v1-1-3.Button-module__yB64MUUF__v1-1-3 {\n  cursor: initial;\n  opacity: 0.3;\n}\n\n.Button-module__2Ma4TaUU__v1-1-3 {\n  background: #ffa319;\n  border-color: transparent;\n  color: #fff;\n}\n.Button-module__2Ma4TaUU__v1-1-3:hover {\n  background: #f29100;\n  color: #fff;\n  text-decoration: none;\n}\n.Button-module__2Ma4TaUU__v1-1-3:focus, .Button-module__2Ma4TaUU__v1-1-3.Button-module__39s3axLP__v1-1-3 {\n  box-shadow: 0 0 0 0.1rem rgba(255, 163, 25, 0.75);\n  outline: none;\n  background: #e58900;\n  color: #fff;\n}\n.Button-module__2Ma4TaUU__v1-1-3:active, .Button-module__2Ma4TaUU__v1-1-3.Button-module__3WXlxxv-__v1-1-3 {\n  background: #d88200;\n}\n.Button-module__2Ma4TaUU__v1-1-3:disabled, .Button-module__2Ma4TaUU__v1-1-3.Button-module__yB64MUUF__v1-1-3 {\n  cursor: initial;\n  opacity: 0.3;\n}\n\n.Button-module__2HCrlzv6__v1-1-3 {\n  background: #fef7eb;\n  border-color: transparent;\n  color: #555;\n}\n.Button-module__2HCrlzv6__v1-1-3:hover {\n  background: #fce8c7;\n  color: #555;\n  text-decoration: none;\n}\n.Button-module__2HCrlzv6__v1-1-3:focus, .Button-module__2HCrlzv6__v1-1-3.Button-module__39s3axLP__v1-1-3 {\n  box-shadow: 0 0 0 0.1rem rgba(254, 247, 235, 0.75);\n  outline: none;\n  background: #fce4ba;\n  color: #555;\n}\n.Button-module__2HCrlzv6__v1-1-3:active, .Button-module__2HCrlzv6__v1-1-3.Button-module__3WXlxxv-__v1-1-3 {\n  background: #fbdfae;\n}\n.Button-module__2HCrlzv6__v1-1-3:disabled, .Button-module__2HCrlzv6__v1-1-3.Button-module__yB64MUUF__v1-1-3 {\n  cursor: initial;\n  opacity: 0.3;\n}\n\n.Button-module__3Eex2siA__v1-1-3 {\n  background: #ec4a3f;\n  border-color: transparent;\n  color: #fff;\n}\n.Button-module__3Eex2siA__v1-1-3:hover {\n  background: #e9291c;\n  color: #fff;\n  text-decoration: none;\n}\n.Button-module__3Eex2siA__v1-1-3:focus, .Button-module__3Eex2siA__v1-1-3.Button-module__39s3axLP__v1-1-3 {\n  box-shadow: 0 0 0 0.1rem rgba(236, 74, 63, 0.75);\n  outline: none;\n  background: #e22316;\n  color: #fff;\n}\n.Button-module__3Eex2siA__v1-1-3:active, .Button-module__3Eex2siA__v1-1-3.Button-module__3WXlxxv-__v1-1-3 {\n  background: #d62115;\n}\n.Button-module__3Eex2siA__v1-1-3:disabled, .Button-module__3Eex2siA__v1-1-3.Button-module__yB64MUUF__v1-1-3 {\n  cursor: initial;\n  opacity: 0.3;\n}\n\n.Button-module__MqwKA-Vc__v1-1-3 {\n  background: #000;\n  border-color: transparent;\n  color: #fff;\n}\n.Button-module__MqwKA-Vc__v1-1-3:hover {\n  background: black;\n  color: #fff;\n  text-decoration: none;\n}\n.Button-module__MqwKA-Vc__v1-1-3:focus, .Button-module__MqwKA-Vc__v1-1-3.Button-module__39s3axLP__v1-1-3 {\n  box-shadow: 0 0 0 0.1rem rgba(0, 0, 0, 0.75);\n  outline: none;\n  background: black;\n  color: #fff;\n}\n.Button-module__MqwKA-Vc__v1-1-3:active, .Button-module__MqwKA-Vc__v1-1-3.Button-module__3WXlxxv-__v1-1-3 {\n  background: black;\n}\n.Button-module__MqwKA-Vc__v1-1-3:disabled, .Button-module__MqwKA-Vc__v1-1-3.Button-module__yB64MUUF__v1-1-3 {\n  cursor: initial;\n  opacity: 0.3;\n}\n\n.Button-module__iJhDdOHm__v1-1-3 {\n  background: #fff;\n  border-color: transparent;\n  color: #555;\n}\n.Button-module__iJhDdOHm__v1-1-3:hover {\n  background: #ececec;\n  color: #555;\n  text-decoration: none;\n}\n.Button-module__iJhDdOHm__v1-1-3:focus, .Button-module__iJhDdOHm__v1-1-3.Button-module__39s3axLP__v1-1-3 {\n  box-shadow: 0 0 0 0.1rem rgba(255, 255, 255, 0.75);\n  outline: none;\n  background: #e6e6e6;\n  color: #555;\n}\n.Button-module__iJhDdOHm__v1-1-3:active, .Button-module__iJhDdOHm__v1-1-3.Button-module__3WXlxxv-__v1-1-3 {\n  background: #dfdfdf;\n}\n.Button-module__iJhDdOHm__v1-1-3:disabled, .Button-module__iJhDdOHm__v1-1-3.Button-module__yB64MUUF__v1-1-3 {\n  cursor: initial;\n  opacity: 0.3;\n}\n\n.Button-module__2tKStPHe__v1-1-3 {\n  background: #fff;\n  border-color: #dce6ec;\n  color: #555;\n  font-weight: 400;\n}\n.Button-module__2tKStPHe__v1-1-3:hover,\n.Button-module__2tKStPHe__v1-1-3 .Button-module__YUN3Kf-p__v1-1-3 {\n  background: #f4f7f9;\n  color: #555;\n}\n.Button-module__2tKStPHe__v1-1-3:focus, .Button-module__2tKStPHe__v1-1-3.Button-module__39s3axLP__v1-1-3 {\n  box-shadow: 0 0 0 0.1rem rgba(255, 255, 255, 0.75);\n  outline: none;\n  background: #dce6ec;\n}\n\n.Button-module__2KZcoTpE__v1-1-3 {\n  background: transparent;\n  border-color: transparent;\n  color: #0db5df;\n}\n.Button-module__2KZcoTpE__v1-1-3:hover {\n  background: #f4f7f9;\n  color: #0db5df;\n  text-decoration: none;\n}\n.Button-module__2KZcoTpE__v1-1-3:focus, .Button-module__2KZcoTpE__v1-1-3.Button-module__39s3axLP__v1-1-3 {\n  box-shadow: 0 0 0 0.1rem rgba(219, 222, 224, 0.75);\n  outline: none;\n  background: #f4f7f9;\n  color: #0db5df;\n}\n.Button-module__2KZcoTpE__v1-1-3:active, .Button-module__2KZcoTpE__v1-1-3.Button-module__3WXlxxv-__v1-1-3 {\n  background: #dbdee0;\n}\n.Button-module__2KZcoTpE__v1-1-3:disabled, .Button-module__2KZcoTpE__v1-1-3.Button-module__yB64MUUF__v1-1-3 {\n  cursor: initial;\n  opacity: 0.3;\n}";
var styles = {"button":"Button-module__3Rp1BYXs__v1-1-3","loadingButtonInner":"Button-module__1JxCag8q__v1-1-3","loadingIcon":"Button-module__PkJtfsRC__v1-1-3","buttonInner":"Button-module__3ZNLhdsJ__v1-1-3","iconOnly":"Button-module__3-vgpZJs__v1-1-3","block":"Button-module__1xc1DTHJ__v1-1-3","default":"Button-module__2Kmo3l-q__v1-1-3","focus":"Button-module__39s3axLP__v1-1-3","active":"Button-module__3WXlxxv-__v1-1-3","disabled":"Button-module__yB64MUUF__v1-1-3","primary":"Button-module__2nxVbZSO__v1-1-3","success":"Button-module__2WMN2Up2__v1-1-3","info":"Button-module__3Ll-h-cW__v1-1-3","warning":"Button-module__2Ma4TaUU__v1-1-3","warning-light":"Button-module__2HCrlzv6__v1-1-3","danger":"Button-module__3Eex2siA__v1-1-3","dark":"Button-module__MqwKA-Vc__v1-1-3","light":"Button-module__iJhDdOHm__v1-1-3","defaultOutline":"Button-module__2tKStPHe__v1-1-3","hover":"Button-module__YUN3Kf-p__v1-1-3","link":"Button-module__2KZcoTpE__v1-1-3"};
styleInject(css_248z);

function ButtonWithRef(_a, ref) {
    var _b, _c, _d, _e, _f, _g;
    var _h = _a.actAsAnchor, actAsAnchor = _h === void 0 ? false : _h, _j = _a.active, active = _j === void 0 ? false : _j, block = _a.block, _k = _a.children, children = _k === void 0 ? null : _k, className = _a.className, _l = _a.disabled, disabled = _l === void 0 ? false : _l, icon = _a.icon, loading = _a.loading, metadata = _a.metadata, _m = _a.onClick, onClick = _m === void 0 ? undefined : _m, outline = _a.outline, _o = _a.theme, theme = _o === void 0 ? 'default' : _o, _p = _a.type, type = _p === void 0 ? 'button' : _p, remainingProps = __rest(_a, ["actAsAnchor", "active", "block", "children", "className", "disabled", "icon", "loading", "metadata", "onClick", "outline", "theme", "type"]);
    var tag = actAsAnchor ? 'a' : 'button';
    var containerClass = classnames__default['default'](styles.button, (_b = {}, _b[styles[theme]] = !outline, _b), (_c = {}, _c[styles[theme + "Outline"]] = outline, _c), (_d = {}, _d[styles.block] = block, _d), (_e = {}, _e[styles.active] = active || loading, _e), (_f = {}, _f[styles.disabled] = disabled, _f), className);
    var focusAwareOnClick = function (event) {
        if (!actAsAnchor)
            event.currentTarget.focus();
        if (onClick)
            onClick(event);
    };
    return React__default['default'].createElement(tag, __assign(__assign(__assign({}, remainingProps), utilsCommons.parseMetadata(metadata)), { className: containerClass, disabled: disabled, onClick: disabled ? undefined : focusAwareOnClick, type: tag === 'button' ? type : undefined, ref: ref }), React__default['default'].createElement(React__default['default'].Fragment, null,
        React__default['default'].createElement("div", { className: classnames__default['default'](styles.buttonInner, (_g = {},
                _g[styles.loadingButtonInner] = loading,
                _g)) },
            icon && React__default['default'].createElement(Icon__default['default'], { name: icon, size: 15 }),
            children && React__default['default'].createElement("div", { className: styles.buttonContent }, children)),
        loading && (React__default['default'].createElement(Icon__default['default'], { name: "spinner-third", size: 15, spin: true, className: styles.loadingIcon }))));
}
ButtonWithRef.displayName = 'Button';
var Button = React__default['default'].forwardRef(ButtonWithRef);

module.exports = Button;
//# sourceMappingURL=index.js.map
